## mapsembler2 2.2.4+dfsg1

=== mapsembler2_extremities/CMakeLists.txt ===
project(mapsembler2_extremities)

cmake_minimum_required(VERSION 2.6)

################################################################################
# Define cmake modules directory
################################################################################
FOREACH (path "cmake" "../cmake"  "thirdparty/gatb-core/cmake"  "../../thirdparty/gatb-core/gatb-core/cmake")
IF (EXISTS "${CMAKE_CURRENT_SOURCE_DIR}/")
SET (CMAKE_MODULE_PATH  "${CMAKE_MODULE_PATH}" "${CMAKE_CURRENT_SOURCE_DIR}/${path}")
ENDIF()
ENDFOREACH(path)

################################################################################
# THIRD PARTIES
################################################################################

# We don't want to install some GATB-CORE artifacts
#SET (GATB_CORE_EXCLUDE_TOOLS     1)
#SET (GATB_CORE_EXCLUDE_TESTS     1)
#SET (GATB_CORE_EXCLUDE_EXAMPLES  1)

# GATB CORE
include(CheckCXXSourceCompiles)
include (FindTR1)
include (GatbCore)


################################################################################
# TOOL
################################################################################

# we get compilation definitions from the gatb-core part
if(UNORDERED_MAP_USE_TR1_UNORDERED_MAP)
	message("-- Add compilation option -DUNORDERED_MAP_TR1_FOUND=1")
	set(gatb-core-flags "${gatb-core-flags} -DUNORDERED_MAP_TR1_FOUND=1")
endif()
add_definitions (${gatb-core-flags})

# we give the headers directories from : 
#       - from project source 
#       - from GATB-CORE source
#       - from dsk source 
include_directories (src  ${gatb-core-includes})

# we define the files to be compiled
file (GLOB_RECURSE  ProjectFiles  src/*)

# we define the artifact to be built: the project binary
add_executable        (${CMAKE_PROJECT_NAME}  ${ProjectFiles})

# we define which libraries to be linked with project binary
target_link_libraries (${CMAKE_PROJECT_NAME}  ${gatb-core-libraries})

=== thirdparty/zlib/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.4.4)
set(CMAKE_ALLOW_LOOSE_LOOP_CONSTRUCTS ON)

project(zlib C)

set(VERSION "1.2.8")

option(ASM686 "Enable building i686 assembly implementation")
option(AMD64 "Enable building amd64 assembly implementation")

set(INSTALL_BIN_DIR "${CMAKE_INSTALL_PREFIX}/bin" CACHE PATH "Installation directory for executables")
set(INSTALL_LIB_DIR "${CMAKE_INSTALL_PREFIX}/lib" CACHE PATH "Installation directory for libraries")
set(INSTALL_INC_DIR "${CMAKE_INSTALL_PREFIX}/include" CACHE PATH "Installation directory for headers")
set(INSTALL_MAN_DIR "${CMAKE_INSTALL_PREFIX}/share/man" CACHE PATH "Installation directory for manual pages")
set(INSTALL_PKGCONFIG_DIR "${CMAKE_INSTALL_PREFIX}/share/pkgconfig" CACHE PATH "Installation directory for pkgconfig (.pc) files")

include(CheckTypeSize)
include(CheckFunctionExists)
include(CheckIncludeFile)
include(CheckCSourceCompiles)
enable_testing()

check_include_file(sys/types.h HAVE_SYS_TYPES_H)
check_include_file(stdint.h    HAVE_STDINT_H)
check_include_file(stddef.h    HAVE_STDDEF_H)

#
# Check to see if we have large file support
#
set(CMAKE_REQUIRED_DEFINITIONS -D_LARGEFILE64_SOURCE=1)
# We add these other definitions here because CheckTypeSize.cmake
# in CMake 2.4.x does not automatically do so and we want
# compatibility with CMake 2.4.x.
if(HAVE_SYS_TYPES_H)
    list(APPEND CMAKE_REQUIRED_DEFINITIONS -DHAVE_SYS_TYPES_H)
endif()
if(HAVE_STDINT_H)
    list(APPEND CMAKE_REQUIRED_DEFINITIONS -DHAVE_STDINT_H)
endif()
if(HAVE_STDDEF_H)
    list(APPEND CMAKE_REQUIRED_DEFINITIONS -DHAVE_STDDEF_H)
endif()
check_type_size(off64_t OFF64_T)
if(HAVE_OFF64_T)
   add_definitions(-D_LARGEFILE64_SOURCE=1)
endif()
set(CMAKE_REQUIRED_DEFINITIONS) # clear variable

#
# Check for fseeko
#
check_function_exists(fseeko HAVE_FSEEKO)
if(NOT HAVE_FSEEKO)
    add_definitions(-DNO_FSEEKO)
endif()

#
# Check for unistd.h
#
check_include_file(unistd.h Z_HAVE_UNISTD_H)

if(MSVC)
    set(CMAKE_DEBUG_POSTFIX "d")
    add_definitions(-D_CRT_SECURE_NO_DEPRECATE)
    add_definitions(-D_CRT_NONSTDC_NO_DEPRECATE)
    include_directories(${CMAKE_CURRENT_SOURCE_DIR})
endif()

if(NOT CMAKE_CURRENT_SOURCE_DIR STREQUAL CMAKE_CURRENT_BINARY_DIR)
    # If we're doing an out of source build and the user has a zconf.h
    # in their source tree...
    if(EXISTS ${CMAKE_CURRENT_SOURCE_DIR}/zconf.h)
        message(STATUS "Renaming")
        message(STATUS "    ${CMAKE_CURRENT_SOURCE_DIR}/zconf.h")
        message(STATUS "to 'zconf.h.included' because this file is included with zlib")
        message(STATUS "but CMake generates it automatically in the build directory.")
        file(RENAME ${CMAKE_CURRENT_SOURCE_DIR}/zconf.h ${CMAKE_CURRENT_SOURCE_DIR}/zconf.h.included)
  endif()
endif()

set(ZLIB_PC ${CMAKE_CURRENT_BINARY_DIR}/zlib.pc)
configure_file( ${CMAKE_CURRENT_SOURCE_DIR}/zlib.pc.cmakein
		${ZLIB_PC} @ONLY)
configure_file(	${CMAKE_CURRENT_SOURCE_DIR}/zconf.h.cmakein
		${CMAKE_CURRENT_BINARY_DIR}/zconf.h @ONLY)
include_directories(${CMAKE_CURRENT_BINARY_DIR} ${CMAKE_SOURCE_DIR})


#============================================================================
# zlib
#============================================================================

set(ZLIB_PUBLIC_HDRS
    ${CMAKE_CURRENT_BINARY_DIR}/zconf.h
    zlib.h
)
set(ZLIB_PRIVATE_HDRS
    crc32.h
    deflate.h
    gzguts.h
    inffast.h
    inffixed.h
    inflate.h
    inftrees.h
    trees.h
    zutil.h
)
set(ZLIB_SRCS
    adler32.c
    compress.c
    crc32.c
    deflate.c
    gzclose.c
    gzlib.c
    gzread.c
    gzwrite.c
    inflate.c
    infback.c
    inftrees.c
    inffast.c
    trees.c
    uncompr.c
    zutil.c
)

if(CMAKE_COMPILER_IS_GNUCC)
    if(ASM686)
        set(ZLIB_ASMS contrib/asm686/match.S)
    elseif (AMD64)
        set(ZLIB_ASMS contrib/amd64/amd64-match.S)
    endif ()

	if(ZLIB_ASMS)
		add_definitions(-DASMV)
		set_source_files_properties(${ZLIB_ASMS} PROPERTIES LANGUAGE C COMPILE_FLAGS -DNO_UNDERLINE)
	endif()
endif()

if(MSVC)
    if(ASM686)
		ENABLE_LANGUAGE(ASM_MASM)
        set(ZLIB_ASMS
			contrib/masmx86/inffas32.asm
			contrib/masmx86/match686.asm
		)
    elseif (AMD64)
		ENABLE_LANGUAGE(ASM_MASM)
        set(ZLIB_ASMS
			contrib/masmx64/gvmat64.asm
			contrib/masmx64/inffasx64.asm
		)
    endif()

	if(ZLIB_ASMS)
		add_definitions(-DASMV -DASMINF)
	endif()
endif()

# parse the full version number from zlib.h and include in ZLIB_FULL_VERSION
file(READ ${CMAKE_CURRENT_SOURCE_DIR}/zlib.h _zlib_h_contents)
string(REGEX REPLACE ".*#define[ \t]+ZLIB_VERSION[ \t]+\"([-0-9A-Za-z.]+)\".*"
    "\\1" ZLIB_FULL_VERSION ${_zlib_h_contents})

if(MINGW)
    # This gets us DLL resource information when compiling on MinGW.
    if(NOT CMAKE_RC_COMPILER)
        set(CMAKE_RC_COMPILER windres.exe)
    endif()

    add_custom_command(OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/zlib1rc.obj
                       COMMAND ${CMAKE_RC_COMPILER}
                            -D GCC_WINDRES
                            -I ${CMAKE_CURRENT_SOURCE_DIR}
                            -I ${CMAKE_CURRENT_BINARY_DIR}
                            -o ${CMAKE_CURRENT_BINARY_DIR}/zlib1rc.obj
                            -i ${CMAKE_CURRENT_SOURCE_DIR}/win32/zlib1.rc)
    set(ZLIB_DLL_SRCS ${CMAKE_CURRENT_BINARY_DIR}/zlib1rc.obj)
endif(MINGW)

add_library(zlib SHARED ${ZLIB_SRCS} ${ZLIB_ASMS} ${ZLIB_DLL_SRCS} ${ZLIB_PUBLIC_HDRS} ${ZLIB_PRIVATE_HDRS})
add_library(zlibstatic STATIC ${ZLIB_SRCS} ${ZLIB_ASMS} ${ZLIB_PUBLIC_HDRS} ${ZLIB_PRIVATE_HDRS})
set_target_properties(zlib PROPERTIES DEFINE_SYMBOL ZLIB_DLL)
set_target_properties(zlib PROPERTIES SOVERSION 1)

if(NOT CYGWIN)
    # This property causes shared libraries on Linux to have the full version
    # encoded into their final filename.  We disable this on Cygwin because
    # it causes cygz-${ZLIB_FULL_VERSION}.dll to be created when cygz.dll
    # seems to be the default.
    #
    # This has no effect with MSVC, on that platform the version info for
    # the DLL comes from the resource file win32/zlib1.rc
    set_target_properties(zlib PROPERTIES VERSION ${ZLIB_FULL_VERSION})
endif()

if(UNIX)
    # On unix-like platforms the library is almost always called libz
   set_target_properties(zlib zlibstatic PROPERTIES OUTPUT_NAME z)
   if(NOT APPLE)
     set_target_properties(zlib PROPERTIES LINK_FLAGS "-Wl,--version-script,\"${CMAKE_CURRENT_SOURCE_DIR}/zlib.map\"")
   endif()
elseif(BUILD_SHARED_LIBS AND WIN32)
    # Creates zlib1.dll when building shared library version
    set_target_properties(zlib PROPERTIES SUFFIX "1.dll")
endif()

if(NOT SKIP_INSTALL_LIBRARIES AND NOT SKIP_INSTALL_ALL )
    install(TARGETS zlib zlibstatic
        RUNTIME DESTINATION "${INSTALL_BIN_DIR}"
        ARCHIVE DESTINATION "${INSTALL_LIB_DIR}"
        LIBRARY DESTINATION "${INSTALL_LIB_DIR}" )
endif()
if(NOT SKIP_INSTALL_HEADERS AND NOT SKIP_INSTALL_ALL )
    install(FILES ${ZLIB_PUBLIC_HDRS} DESTINATION "${INSTALL_INC_DIR}")
endif()
if(NOT SKIP_INSTALL_FILES AND NOT SKIP_INSTALL_ALL )
    install(FILES zlib.3 DESTINATION "${INSTALL_MAN_DIR}/man3")
endif()
if(NOT SKIP_INSTALL_FILES AND NOT SKIP_INSTALL_ALL )
    install(FILES ${ZLIB_PC} DESTINATION "${INSTALL_PKGCONFIG_DIR}")
endif()

=== mapsembler2_extremities/thirdparty/gatb-core/src/CMakeLists.txt ===
################################################################################
#  KMER SIZE DEFINITION 
################################################################################

# We define several sizes of kmers
SET (KSIZE_1  "32")
SET (KSIZE_2  "64")
SET (KSIZE_3  "96")
SET (KSIZE_4 "128")

# Users can overwrite the fourth value
IF (k1)
    SET (KSIZE_1 ${k1})
ENDIF()

IF (k2)
    SET (KSIZE_2 ${k2})
ENDIF()

IF (k3)
    SET (KSIZE_3 ${k3})
ENDIF()

IF (k4)
    SET (KSIZE_4 ${k4})
ENDIF()

MESSAGE ("-- SUPPORTED KMER SIZES ARE ${KSIZE_1} ${KSIZE_2} ${KSIZE_3} ${KSIZE_4}")

################################################################################
#  CONFIGURATION FILE
################################################################################
configure_file (
    ${PROJECT_SOURCE_DIR}/src/gatb/system/api/config.hpp.in 
    ${PROJECT_BINARY_DIR}/include/gatb/system/api/config.hpp
)

################################################################################
#  LIBRARY GENERATION 
################################################################################

file (GLOB_RECURSE  ComponentFiles  *)

# We add the compilation options for the library
add_definitions (${gatb-core-flags})

include_directories (${gatb-core-includes})

add_library    (gatbcore-static  STATIC  ${ComponentFiles} )
#add_library   (gatbcore-dynamic SHARED  ${ComponentFiles} )

set_target_properties  (gatbcore-static   PROPERTIES OUTPUT_NAME  gatbcore  clean_direct_output 1)
#set_target_properties (gatbcore-dynamic  PROPERTIES OUTPUT_NAME  gatbcore  clean_direct_output 1)

################################################################################
#  INSTALLATION 
################################################################################

# We install the libraries
IF (NOT DEFINED GATB_CORE_INSTALL_EXCLUDE)
    install (TARGETS gatbcore-static DESTINATION lib)
    install (DIRECTORY ${PROJECT_SOURCE_DIR}/src/ DESTINATION include FILES_MATCHING PATTERN "*.hpp" PATTERN "*.tpp" PATTERN "*.pri")
    install (FILES ${PROJECT_BINARY_DIR}/include/gatb/system/api/config.hpp DESTINATION include/gatb/system/api/)
ENDIF ()

=== mapsembler2_extremities/thirdparty/gatb-core/test/unit/CMakeLists.txt ===
################################################################################
#  CPPUNIT 
################################################################################

# We add the compilation options for the library
add_definitions (${gatb-core-flags})

file (GLOB_RECURSE  GatbCoreTestFiles  src/*)

include_directories (${gatb-core-includes}  ${gatb-core_SOURCE_DIR}/test/unit/src  ${CPPUNIT_INCLUDE_DIR})

# We add the path for extra libraries
link_directories (${gatb-core-extra-libraries-path})

add_executable        (gatb-core-cppunit    ${GatbCoreTestFiles})
target_link_libraries (gatb-core-cppunit    ${gatb-core-libraries} ${CPPUNIT_LIBRARY_STATIC})

#################################################
#  LAUNCH 
#################################################

# We add an optional target for launching unit tests
add_custom_target (test gatb-core-cppunit  "All Tests"  ${gatb-core_SOURCE_DIR}/test/db  unittests.xml)

#################################################
#  INSTALL 
#################################################
install (TARGETS gatb-core-cppunit   DESTINATION test)
install (DIRECTORY ${gatb-core_SOURCE_DIR}/test/db DESTINATION test/)

=== debian/changelog ===
mapsembler2 (2.2.4+dfsg1-5) unstable; urgency=medium

  * Fix build using CMake 4
    Closes: #1113267
  * d/watch: version=5
  * Standards-Version: 4.7.2 (routine-update)
  * debputy lint --auto-fix (routine-update)

 -- Andreas Tille <tille@debian.org>  Sat, 18 Oct 2025 22:45:15 +0200

mapsembler2 (2.2.4+dfsg1-4) unstable; urgency=medium

  * d/salsa-ci.yml: disable i386 build and reprotest in Salsa CI
  * d/control: updated uploader address
  * d/control: standard version 4.5.1
  * d/mans/mapsembler2_kissreads.1: fix typo-in-manual-page
  * spelling.patch: fix spelling-error-in-binary
  * add gcc11.patch (Closes: #984226)
  * d/s/lintian-overrides: override notices about components not sent, or
    otherwise missing about upstream, who is inactive for a while.
  * Standards-Version: 4.6.0 (routine-update)

 -- Étienne Mollier <emollier@debian.org>  Fri, 20 Aug 2021 10:21:44 +0200

mapsembler2 (2.2.4+dfsg1-3) unstable; urgency=medium

  [ Helmut Grohne ]
  * Fix FTCBFS: (Closes: #972807)
    + Let dh_auto_* handle cross compilation.
    + cross.patch: Use CXX for a C++ compiler.

  [ Étienne Mollier ]
  * List supported autopkgtest architectures, no 32 bit anymore.
  * Add myself to uploaders.

 -- Étienne Mollier <etienne.mollier@mailoo.org>  Mon, 09 Nov 2020 18:01:18 +0100

mapsembler2 (2.2.4+dfsg1-2) unstable; urgency=medium

  * Team upload.
  * also remove 32 bits architectures from debian/control.

 -- Étienne Mollier <etienne.mollier@mailoo.org>  Wed, 21 Oct 2020 22:58:31 +0200

mapsembler2 (2.2.4+dfsg1-1) unstable; urgency=medium

  * Team upload.
  * added no_std_hash_redefinition.patch and gcc10.patch to address compilation
    failures with Gcc 10.  (Closes: #957519)
  * package removed from 32 bits architecture repostories due to test failure
    and end of maintenance upstream.
  * added check_memory.patch to clarify memory allocation errors in
    autopkgtests, but also in general use.
  * excluded cmake build directory in gatb-core examples, as they are unusable,
    and the CMakeCache.txt triggers a lintian error.
  * made the build more verbose to check for build flags.

 -- Étienne Mollier <etienne.mollier@mailoo.org>  Tue, 20 Oct 2020 23:09:57 +0200

mapsembler2 (2.2.4+dfsg-4) unstable; urgency=medium

  [ Steffen Möller ]
  * Added ref to conda

  [ Pranav Ballaney ]
  * Add reference data for autopkgtests
  * Add autopkgtests
  * Install docs

  [ Andreas Tille ]
  * Standards-Version: 4.5.0 (routine-update)
  * debhelper-compat 13 (routine-update)
  * Add salsa-ci file (routine-update)
  * Rules-Requires-Root: no (routine-update)
  * Trim trailing whitespace.
  * Refer to specific version of license GPL-2+.

 -- Pranav Ballaney <ballaneypranav@gmail.com>  Sat, 13 Jun 2020 05:43:14 +0530

mapsembler2 (2.2.4+dfsg-3) unstable; urgency=medium

  * Provide mapsembler2_extend as symlink to mapsembler_extend since
    it is used in pipeline script (Thanks for the hint to Horacio
    Montenegro <h.montenegro.cluster@gmail.com>)
    Closes: #912662
  * Remove trailing whitespace in debian/changelog
  * Remove trailing whitespace in debian/copyright

 -- Andreas Tille <tille@debian.org>  Sat, 03 Nov 2018 07:15:54 +0100

mapsembler2 (2.2.4+dfsg-2) unstable; urgency=medium

  [ Steffen Moeller ]
  * Created debian/upstream/metadata

  [ Andreas Tille ]
  * debhelper 11
  * Point Vcs fields to salsa.debian.org
  * Standards-Version: 4.2.1
  * d/rules:
     - Drop unneeded get-orig-source target
     - Do not parse d/changelog
  * Fix spelling
  * Create manpages before package creation

 -- Andreas Tille <tille@debian.org>  Wed, 10 Oct 2018 15:07:09 +0200

=== debian/control ===
Source: mapsembler2
Standards-Version: 4.7.2
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders:
 Olivier Sallou <osallou@debian.org>,
 Andreas Tille <tille@debian.org>,
 Étienne Mollier <emollier@debian.org>,
Section: science
Priority: optional
Build-Depends:
 debhelper-compat (= 13),
 cmake,
 bc,
 zlib1g-dev,
 libhdf5-dev,
 libcppunit-dev,
 libboost-dev,
Vcs-Browser: https://salsa.debian.org/med-team/mapsembler2
Vcs-Git: https://salsa.debian.org/med-team/mapsembler2.git
Homepage: http://colibread.inria.fr/mapsembler2/
Rules-Requires-Root: no

Package: mapsembler2
Architecture: amd64 arm64 kfreebsd-amd64 ppc64el s390x
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
 zlib1g,
 bc,
Description: bioinformatics targeted assembly software
 Mapsembler2 is a targeted assembly software.
 It takes as input a set of NGS raw reads (fasta or fastq, gzipped or not)
 and a set of input sequences (starters).
 .
 It first determines if each starter is read-coherent, e.g. whether reads
 confirm the presence of each starter in the original sequence.
 Then for each read-coherent starter, Mapsembler2 outputs its sequence
 neighborhood as a linear sequence or as a graph, depending on the user choice.
 .
 Mapsembler2 may be used for (not limited to):
  - Validate an assembled sequence (input as starter), e.g. from a de
    Bruijn graph assembly where read-coherence was not enforced.
  - Checks if a gene (input as starter) has an homolog in a set of reads
  - Checks if a known enzyme is present in a metagenomic NGS read set.
  - Enrich unmappable reads by extending them, possibly making them mappable
  - Checks what happens at the extremities of a contig
  - Remove contaminants or symbiont reads from a read set

=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

include /usr/share/dpkg/default.mk

ifneq ($(wildcard /usr/include/hdf5/serial),)
  export DEB_CPPFLAGS_MAINT_APPEND := -I/usr/include/hdf5/serial
  export DEB_LDFLAGS_MAINT_APPEND := -Wl,-L/usr/lib/$(DEB_HOST_MULTIARCH)/hdf5/serial
endif

CPPFLAGS:=$(shell dpkg-buildflags --get CPPFLAGS)
CFLAGS:=$(shell dpkg-buildflags --get CFLAGS) $(CPPFLAGS)
CXXFLAGS:=$(shell dpkg-buildflags --get CXXFLAGS) $(CPPFLAGS)
LDFLAGS:=$(shell dpkg-buildflags --get LDFLAGS)

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- -DCMAKE_POLICY_VERSION_MINIMUM=3.5

override_dh_auto_build:
	dh_auto_configure --sourcedirectory=mapsembler2_extremities --builddirectory=mapsembler2_extremities/build
	dh_auto_build --sourcedirectory=mapsembler2_extremities --builddirectory=mapsembler2_extremities/build
	dh_auto_build --sourcedirectory=mapsembler2_extend -- k=29
	dh_auto_build --sourcedirectory=kissreads_graph -- k=29
	dh_auto_build --sourcedirectory=kissreads -- k=29

override_dh_clean:
	rm -rf mapsembler2_extremities/build
	cd mapsembler2_extend && make clean
	rm -f mapsembler2_extend/mapsembler_extend
	cd kissreads_graph && make clean
	rm -f kissreads_graph/mapsembler2_kissreads_graph
	cd kissreads && make clean
	rm -f kissreads/mapsembler2_kissreads

	dh_clean

override_dh_install:
	mv ./kissreads/kissreads ./kissreads/mapsembler2_kissreads
	mv ./kissreads_graph/kissreads_graph ./kissreads_graph/mapsembler2_kissreads_graph
	cp run_mapsembler2_pipeline.sh run_mapsembler2_pipeline
	dh_install

=== debian/watch ===
Version: 5

Source: https://colibread.inria.fr/software/@PACKAGE@/
Matching-Pattern: .*/@PACKAGE@_(2\.[.\d]+)@ARCHIVE_EXT@
Repack-Suffix: +dfsg
Dversion-Mangle: auto
